
# [v3.2.2] - 2024-12-16 

## BACKEND

### Fixed

- notification-service: fix return in error code

## FRONTEND

### Added

- vue-ng-lib: Implement autocomplete in computed dialog (#52269)

### Fixed

- vue-ng-lib: Fix crash in dms hist data processing in chart composable (#52270).

### Other

- vue-ng-lib: Update manifest when dms template saved.


# [v3.2.1] - 2024-12-12 

## BACKEND

### Fixed

- rest-service: Send 404 if file not found.

## FRONTEND

### Fixed

- vue-ng-lib: Create new templates and panels (#52257)
- vue-ng-lib: Web-components submit behavior has been fixed
- vue-ng-lib: Pie charts are getting their values by summing their hist data values up
- vue-ng-lib: Correct interpolation type for pie charts

### Other

- New: Historical data can be multiplied by multiplication factor (#51990)

## CONFIGURATION

### Fixed

- rest-data: Web-component config dialog is fixed


# [v3.2.0] - 2024-12-12 

## BACKEND

### Added

- ProcessManager: Add status and statusText to servers
- app-server: Add GET-request for reading the HTML file MD5 (#50644).
- app-server: Update readme (#50644)
- app-server: Create md5 hash from html files to set the hash in response header (#50644)
- apigateway: Improve timeout on addon init (#50933)
- apigateway: Watch policy filechange on startup while processing addon files (#50933)
- apigateway: Add isLocal property to discovery item to add auth token to header on proxy request.
- apigateway: Implement hash password instead of plain-text at startup in users-addon (#51114).
- apigateway: Option to Disable HTTP and Redirect HTTP to HTTPS (#50370).
- rest-service: add no content query parameter to filedb read
- rest-service: Add filepathes to indexer when importing zip or files
- rest-service: Implement paginator within filedb (#52101)
- rest-service: Add tryUserData query parameter to check if we have a user-specific file in user-data.
- rest-service: Implement file indexing for better glob request performance (#51975).
- rest-service: Force copy files on startup into projectdb if pattern matched (#51740).

### Removed

- rest-service: Remove console logs

### Fixed

- apigateway: Fix;Fix save abac policies (#52074).
- DMS: Fix loading of alarms with process control functions (#51961)
- DbData: Fix replacements for {dataBackupPath} (#51528).
- DbData: All timestamps are considered for multiple hist data (#51713)
- PCDDiver: Fix setting of invalid IP (#51542).
- ProcessManager: Fix for duplicated instance names.
- ProcessManager: Fix last start timestamp (#51595).
- ProcessManager: Fix crash on invalid log id (#51496).
- ProcessManager: Fix changes for executableFilePath (#51479).
- ProcessManager: Fix dynamic discovery port for servers api request (#51135).
- ProcessManager: Fix memory usage info on bookworm (#51002).
- rest-service: Fix replaces on rename and copy and implement rename on import.
- rest-service: fix rename file indexer and implement update index
- rest-service: Fix regex index matcher
- rest-service: Fix;Use customized flag parser to avoid panic exit on undefined flags (#52073)
- rest-service: fix fileindex delete path
- rest-service: fix fileindex lookup only on path not filename
- mqttdriver: Publish JSON payload fix tree struct data from dms to valid json (#51719).
- mqttdriver: Fix wrong template search string replacement
- psc2json: Groupped objects get their coordinated correct (#51316)
- psc2json: Discovery server is getting automatically + using of https is fixed (#51135)
- psc2json: The group that contains clickable objects should not be clickable (#51150)
- psc2json: Click propagation is fixed (#50980)

### Other

- app-updater: Update postinstBeforeStart.tengo
- app-updater: New update script to delete the bar chart from web-components folder (#51714)
- DMS: Multiple pathes for hist data can be provided (#51713)
- DMS: Increase JSON limits (#50934).
- MailDriver: New format for LOYTEC csv (#50949).
- OPC UA Stack: Update from v1.8.3.628 to v1.8.4.632 (#50231).
- OPC UA Stack: Update lib to version 1.8.5
- ProcessManager: Process templates are ordered now.
- KNXDriver: New; 61; Some missing datapoints can be skipped in logging (#50930)
- apigateway: Save or create a access-token on startup.
- apigateway: Optimize error log for ldap provider
- apigateway: Update packages
- rest-service: Update explore function to read files to.
- rest-service: Readout shared access token on startup.
- rest-service: Implement regex for fileindexer
- rest-service: Implement status server
- mqttdriver: Create datapoint in dms if type is defined

## FRONTEND

### Added

- vue-ng-lib: New Tree-Component using the ExpandItem (#51957).
- vue-ng-lib: Change permissions on all selected widgets at once (#51873)
- vue-ng-lib: Additional refactoring of subcription/script link type (#46972)
- vue-ng-lib: Expand DMS search (#51218).
- vue-ng-lib: Export of Changelog, Refactor Dialog for Export (#50803).
- vue-ng-lib: Add confirm button to color picker (#44232).
- vue-ng-lib: Create Export / Import for the Engineering-Alarmlist (#51302)
- vue-ng-lib: Feature;Remove ungrouped template from computed handler (#51460).
- vue-ng-lib: Banner for Page reload if a new version exists (#50644).
- vue-ng-lib: DetailView keeps the selected Cell when navigating back (#51301).
- vue-ng-lib: Add create style and script to window
- vue-ng-lib: HTTP can be disabled or redirected to HTTPS (#50370).
- vue-ng-lib: Templates translation from manifest (#51304).
- vue-ng-lib: Alarm comments can be added as well for historical alarms (#51309)
- vue-ng-lib: Remove navigate button if navigation is not possible (#51300).
- vue-ng-lib: Culture-settings for Spreadsheet (#51303).
- vue-ng-lib: Feature;Implement F1 Help in designer and implement keypress composable and update mdeditor component.
- vue-ng-lib: Mutual comments can be added to multiple alarms when they are getting acknowledged (#46765)
- vue-ng-lib: Alarm list only shows alarms from selected datapoint (#51216).
- vue-ng-lib: Change the display of the Spreadsheets of TRD, ALM und PRT in Engineering. ALM will also be grouped now (#50941).
- vue-ng-lib: Add flat as prop to panel
- vue-ng-lib: Add Navigation to Engineering Detailview (#51097)
- vue-ng-lib: Add export-mode to NgDMSNodeChart (#48976)
- vue-ng-lib: add has more alarms
- vue-ng-lib: Add sidelabel for Template Select Field (#50600).

### Removed

- vue-ng-lib: Remove scale merge in templates to avoid wrong sizing in pathes
- vue-ng-lib: Remove deprecated designer models
- vue-ng-lib: Remove unused imports (#50852).

### Fixed

- vue-ng-lib: Close all tabs if bmo has been changed (#51620)
- vue-ng-lib: Permissions to get/write alarm comments are added
- vue-ng-lib: Fix computed input cell and reset hidden on template panel widget and refactor blur event on input.
- vue-ng-lib: Add caption to DMSInterpolation
- vue-ng-lib: Fix alarmtable without workspaceUuid
- vue-ng-lib: siteGroup does no longer have the value 0 multiple times in the request payload  (#52176).
- vue-ng-lib: Update components, fix toService call for template links.
- vue-ng-lib: Break computed calling on event if a computed object is active (#52119).
- vue-ng-lib: Fixes for pie charts (#51715)
- vue-ng-lib: Fix of chart component (#51715)
- vue-ng-lib: Changelog counter has been fixed (#51808)
- vue-ng-lib: Changelog counter is fixed (#51808)
- vue-ng-lib: Enabled types blocked selection in computed item in designer (#51904).
- vue-ng-lib: Fix changelog tab format and fix gradient computing save on automated compute.
- vue-ng-lib: Process image jump from alarmlist to designer (#51839).
- vue-ng-lib: Correct parsing of defined range and interval (#51716)
- vue-ng-lib: Fix missing columns on update table cols and optimize components.
- vue-ng-lib: Fix;Show links in runtime and edit mode (#51748).
- vue-ng-lib: Fix warnings
- vue-ng-lib: Diff interpolation type is handled correctly (#51712)
- vue-ng-lib: Interval is stored correctly (#51707)
- vue-ng-lib: Size of the pop up dialogs is fixed (#51636)
- vue-ng-lib: Workspaces in roles for abac fix selectable options (#50183).
- vue-ng-lib: Fix gradient error
- vue-ng-lib: Control if filter exists
- vue-ng-lib: Fix template panel drag
- vue-ng-lib: Create new idents after paste tabs and fix doublicated idents in existing panels (#50790).
- vue-ng-lib: Fix designer focus on editor, save template in selection action and update drawer repo.
- vue-ng-lib: Do not drag undefined items and log warnings if item not found in draggable composable (#51405)
- vue-ng-lib: Fix ngconfig logger error, fix max recursive calls, fix designer click href
- vue-ng-lib: Fix propagated panel open
- vue-ng-lib: Fix propagated panel open
- vue-ng-lib: Display the DMS-Path again in the Resource list (#51305).
- vue-ng-lib: NgDMSNodeImport component is refactored (#50818)
- vue-ng-lib: Fix;Designer computed gradient fixed (#51339).
- vue-ng-lib: Reactive data for alarm comments is fixed
- vue-ng-lib: Wrong import pathes, change from absolute to relative.
- vue-ng-lib: Update components and fix a ngconfig bug.
- vue-ng-lib: Fix wrong positioning when saving page and merging templates in designer (#50852).
- vue-ng-lib: Toggle of boolean constant has been fixed
- vue-ng-lib: In filtetree a point in the folder name is shown because it's not an extension (#50823).
- vue-ng-lib: Comment popup has been fixed and is shown till the cell is active (#50939)
- vue-ng-lib: Refactor workspace alarm table (#50948).
- vue-ng-lib: New; shift parameters can be restricted to x1 and x2 limits (#51316)
- vue-ng-lib: Full path of dp is shown in engineering detail view (#50940)
- signin: Fix translation loading (#51052)

## CONFIGURATION

### Added

- rest-data: New types of pie charts have been added (#51715)
- rest-data: Translation is added (#51713)
- rest-data: Update designer lang (#51873).
- rest-data: Border radius of the diagram has been added to the parameters (#51685)
- rest-data: Display log in status page(#50821).
- rest-data: Feature;Implement custom user-data for modules cfg and custom pages (#48591).
- rest-data: Size and color of toolbar can be adjusted (#47249)
- rest-data: Web diagram components are updated (#47168)

### Fixed

- rest-data: Remove toolbar download button in chart in main ngui (#52075).
- rest-data: Multiplication factor of charts has been fixed (#51990)
- Fix: xAxis Timestamps has been fixed (#52201)
- rest-data: Status table cells are updated correctly (#52143)
- rest-data: Override height according dom-element height and not the custom data (#51887)
- rest-data: Update language files (#51839).
- rest-data: Select boxes look and feel has been fixed (#51741)
- rest-data: Interpolations id are fixed (#51588)
- rest-data: Fix default 'dataBackupPath' (#51528).
- rest-data: Fix visibility for executableFilePath (#51479)
- rest-data: Set, reset, toggle and impulse signals are implemented (#51100)


# [v3.1.1] - 2024-09-23 

## BACKEND

### Added

- app-updater: Add processManagerEndpoint argument for Api-Gateway and Dms-Broker (#50443).
- DMS: Add "offsetMinFromUTC" for historical data request (#50094).
- DMS: Add "showChilds" for get request (#50272).
- DMS: NAME and OBJECT are added to simulated groups (#50018).
- KNXDriver: Fix; 59; Additional knx types are suported (#50060).
- apigateway: Add base auth and allow all origins.
- apigateway: Add operating groups to addons.
- apigateway: Update workspace_read addon to enable get discovery endpoint.
- rest-service: Uploaded file can be set to be lowercased.
- dms-proxy: Add implement proxy communication with instanceUuid and or processUuid by calling processManager api (#50444).
- ProcessManager: Add processManagerEndpoint argument for Api-Gateway and Dms-Broker (#50443).
- ProcessManager: Add filterProcessName for template request.
- ProcessManager: Add categories for process templates (#50107).

### Changed

- ProcessManager: Refactored netatmo driver (#49321).

### Fixed

- DMS: Fix type checking for json data (#50442).
- DMS: Fix loading combined alarms and process control functions (#50474).
- DMS: New alarm and changelog list from all protocols (#50632).
- CPP-Modules: Fix UTF8 invalid characters in file path (#50612).
- DeviceDrivers: Update PRG content on bmo update (#45969).
- ProcessManager: Avoid start jobs on process manager terminate (#50388).
- Device-API's: Fix wrong configuration detection (#49098).
- DeviceAPI's: Fix crash on deleted device configuration (#49098).
- OPC_UA_Client_API: Fix crash on single node read (#49098).
- apigateway: Fix restart after server settings change lookup for apigateway uuid (#50802).
- apigateway: Refactor server settings with new models (#50802).
- apigateway: Update cli flags and arguments in process (#50360).
- apigateway: Fix user specific tls key and cert upload (#50196).
- apigateway: Enabling setting port number full range of 16bit (#50095).
- rest-service: Json body is parsed correctly (#50527)


## FRONTEND

### Added

- vue-ng-lib: Add Buttons to Spreadsheet and implemented in Engineering-Detail View (#50817)
- vue-ng-lib: Alarms are only visible according to the OperatingGroups (#48886).
- vue-ng-lib: Add OperatingGroupInfo component (#48886).
- vue-ng-lib: Add serie name property to dms chart component (#50369).
- vue-ng-lib: Implement help and tooltip per input component (#50399).
- vue-ng-lib: Range by minutes of the diagram is stored in local storage (#50075).
- vue-ng-lib: NgSpreadsheet component supports the display of icons (#50354).
- vue-ng-lib: Column can be (in-)visible (#50350).
- vue-ng-lib: Update date and datetime input for parsing numbers and add soft-static linking to computed object. (#50339).
- vue-ng-lib: Add nexttick to ng config form props parsing (#50318).
- vue-ng-lib: NgSpreadsheet component supports custom ContextMenu-entrys (#50197).
- vue-ng-lib: Add support for multiple datatypes per column in NgSpreadjs (#50256)
- vue-ng-lib: New menu added to move a selected object to 1 px distance (#47521).
- vue-ng-lib: a title for object panel dialog can be predefined (#50132).

### Removed

- vue-ng-lib: Remove input min max because we use rules as limit in port settings (#50095).

### Fixed

- vue-ng-lib: Fix alarm count in alarm table (#50931).
- vue-ng-lib: Fix clone object in ng config components (#50209).
- vue-ng-lib: Do not break requesting workspace servers if one is not reachable (#50805).
- vue-ng-lib: Refactor computed dialog default item and compute behaviour (#50537).
- vue-ng-lib: Disable seamless false on link dialogs to keep editing input in other dialogs enabled (#50419).
- vue-ng-lib: Refactor chart component (#50368).
- vue-ng-lib: Set value dialog ic closed after submitting the value (#50175)
- vue-ng-lib: Fix help and tooltip in form input (#50404).
- vue-ng-lib: Fix collect tab widgets variables and do not set prev digit value if undefined (#50324).
- vue-ng-lib: Fix reactivity in NgConfig Forms and display captions by forms as markdown (#50318).
- vue-ng-lib: Fix port limitation and implement set buttons for default ports (#50095).

### Other

- vue-ng-lib: Notify server settings error if exists (#50196).
- vue-ng-lib: Start-time, end-time and interval of the chart objects are stored in local storage (#50075).
- vue-ng-lib: Implement hidden Pages in designer with hidden, permissions und roles (#50104).

## CONFIGURATION

### Added

- rest-data: Disable add multiple singleton processes (#50239).
- rest-data: Implement serie name input in chart widget (#50369).
- rest-data: Implement options amount variable in select widget for dynamic options (#50432).
- rest-data: Add description to suffix input and fix empty date in date widget(#50339).
- rest-data: Add exclude nodes for OPC UA (#49098).
- rest-data: Translations are added. Title of setvalue dialog can be predefined (#50132)

### Fixed

- rest-data: Fix web configuration ad/remove bus (#50338).
- rest-data: Set value dialog if closed after submitting the value (#50175).
- rest-data: Fix computed label in state widget (#50424).
- rest-data: Set property alarm as object if not defined in workspace (#50374).
- rest-data: Set empty object in header-modifier to get valid payload. (#50400).
- rest-data: Fix reactivity in widget attributes (#50318).

### Other

- rest-data: Refactor digits in number widget (#50324).
- rest-data: Update lang for default ports (#50095)


# [v3.1.0] - 2024-07-17 

## BACKEND

### Added

- intelli-service: Add widget names migration.
- intelli-service: Add portal job start.
- intelli-service: Add alarm counter.
- intelli-service: Add annotation time normalization.
- genstx: Add newest library.
- genstx: New model applications and delimiter implementation (#48282).
- genstx: New package server extend server with warning and log emitter (#49964).

### Changed

- intelli-service: Change parentNode to yAxis.
- intelli-service: Change portal api endpoint name.

### Fixed

- api-broker: Api-Broker sparql client is fixed - missed accept header has been added (#49626).
- DMS: Fix short get command (#50078).
- DMS: Fix copy node recursion (#49540).
- Setup: Fix;; uninstall/install of vcredist 2019 (#49124).
- intelli-service: Fix alarm handler.
- Designer: Image Files are structured in rest-db (#49969).
- Designer: Destination folder for project images is fixed (#49954).

### Other

- apigateway: Implement access-token login through auto login.
- apigateway: Always remove allow origin in proxy stack because we handle it in single reverse proxy.
- apigateway: Refactor settings and run server http and https per default.
- mqttdriver: Optimize log if DMS sends errors in set (#49205).

## FRONTEND

### Added

- vue-ng-lib: Add i18n translation to md editor.
- vue-ng-lib: Accepted files extensions are added (#47724).
- bai: Add multi row deletion.

### Changed

- vue-ng-lib: Changed readonly attribute name.
- vue-ng-lib: Prefix for export can be empty (#49478).

### Fixed

- vue-ng-lib: Refactor adds NgButton if only one entry exists.
- vue-ng-lib: Diff and time are added to "TRD DP add" dialog (#48787).
- vue-ng-lib: Add NgDMSAlarmColorTable Component.
- vue-ng-lib: Prepare info prop for components and add css style to markdown (#49316).
- vue-ng-lib: Fix key on select server (#41179).
- vue-ng-lib: Fix inject serviceUuids from parent to childs (#41179).
- vue-ng-lib: Fix of design dms node chart component (#49671).
- vue-ng-lib: Fix of NgDMSNodeChart Component (#49671).
- vue-ng-lib: Fix of NgDMSAlarmInstructions sizes (#49627)
- vue-ng-lib: Fix missing set interpolation in dms chart (#49585).
- vue-ng-lib: Fix missing endpoints in EndpointRepository (#49577).
- vue-ng-lib: Web Component rendering has been fixed.
- vue-ng-lib: Fix rendering Asnyc-Component import in NgUI (#49333).
- vue-ng-lib: Fix update model value in splitter (#49328).
- vue-ng-lib: Fix unsetted data in useForm for NgControls (#49038).
- vue-ng-lib: Fix maximum stack call and optimize key variables (#49038).
- vue-ng-lib: Fix undefined focus emitter.
- vue-ng-lib: Fix copy paste widgets in template panel (#49313).
- Designer: Reinitialisation of the dialog objects is fixed (#49965).
- bai: Fixed config model folder deletion on page deletion if no configModel exists.

### Other

- vue-ng-lib: Implement secure communication between NGs (#41179).
- vue-ng-lib: Remove save config in dms-chart because this is not needed (#49585).
- vue-ng-lib: AlarmInstructions component has been refactored (#47724).
- vue-ng-lib: New component for assignment of the alarms texts is implemented (#47724).
- vue-ng-lib: Debounce splitter update (#49328).
- vue-ng-lib: Emit selected events (#49317).
- vue-ng-lib: Double click emit on group item (#49313).
- vue-ng-lib: Copy paste template panel tabs (#49315).

## CONFIGURATION

### Added

- rest-data: Add applications (#48282).
- rest-data: Add alarm format to alarm page.

### Fixed

- rest-data: Fix chart widget by setting the correct processManagerUuid in chart nodes.
- rest-data: fix wrong labels (#48068).
- rest-data: Fix of change image web component (#47275).
- rest-data: Fix call onInit in mounted hook, call it in onSubscribed callback (#49585).
- rest-data: Fix NgSplitter in modules (#49328).

### Other

- rest-data: Implement secure service communication (#41179).
- rest-data: dms.chart component has been updated (#49671).
- rest-data: Web components are adjusted (#47275).
- rest-data: Optimize dms.chart Web-Component for designer (#49581).
- rest-data: Translations are adjusted (#48787).
- rest-data: Lang for template panel info (#49316).


# [v3.0.1] - 2024-06-10

## General

- Initial stable setup

