/* eslint-disable @typescript-eslint/restrict-template-expressions */
/* eslint-disable @typescript-eslint/no-unsafe-return */
/* eslint-disable @typescript-eslint/no-unsafe-member-access */
/* ts-ignore */

export const ButtonCounter = () => ({
  name: 'ButtonCounter',
  props: ['initalCounter'],
  emits: [
    // 'updateCounter',
  ],
  data() {
    return {
      counter: this.initalCounter || 0,
    };
  },
  mounted() {
    console.log('mounted', this);
    this.$emit('updateCounter', this.counter);
  },
  nodes() {
    console.log('nodes', this);
    return [
      {
        type: 'NgActionButton',
        props: {
          label: 'Counter',
          caption: this.counter,
          // event props needs to have an on prefix. Eventname click => onClick
          onClick: () => {
            this.counter += 1;
            this.$emit('updateCounter', this.counter);
          },
        },
      },
    ];
  },
});

export const FormInput = () => ({
  name: 'FormInput',
  props: ['modelValue'],
  emits: [
    'update:modelValue',
  ],
  data() {
    return {
    };
  },
  // Hooks https://vuejs.org/api/composition-api-lifecycle.html do not use on
  mounted() {
    console.log('mounted', this);
  },
  beforeMount() {
    console.log('beforeMount', this);
  },
  nodes() {
    return [
      {
        type: 'NgFormInput',
        props: {
          label: 'Counter',
          modelValue: this.modelValue,
          // event props needs to have an on prefix. Eventname update:modelValue => onUpdate:modelValue
          'onUpdate:modelValue': (val) => { this.$emit('update:modelValue', val); },
        },
      },
    ];
  },
});

export const CatList = () => ({
  name: 'CatList',
  props: ['limit'],
  emits: [
    'update:modelValue',
  ],
  data() {
    return {
      amount: 10,
      loading: true,
      meow: {
        data: [],
      },
    };
  },
  // Hooks https://vuejs.org/api/composition-api-lifecycle.html do not use prefix on, onMounted goes to mounted.
  mounted() {
    console.log('mounted', this);
    this.loading = true;
    this.ctx.axios.get(`https://meowfacts.herokuapp.com/?count=${this.limit || this.amount}`)
      .then((res) => {
        const { data } = res;
        this.meow = data;
      })
      .catch((err) => {
        this.ctx.notify.notifyApiError(err);
      })
      .finally(() => {
        this.loading = false;
      });
  },
  beforeMount() {
    console.log('beforeMount', this);
  },
  nodes() {
    return [
      {
        type: 'NgLoading',
        props: {
          modelValue: this.loading,
          'onUpdate:modelValue': (val) => { this.loading = val; },
        },
      },
      {
        type: 'NgList',
        props: {
          title: 'Cat Meow',
          separator: true,
          style: {
            display: this.loading ? 'none' : '',
          },
        },
        children: {
          default: () => {
            const items = this.meow.data.map((cat) => ({
              type: 'NgListItem',
              props: {
                title: cat,
              },
            }));

            return items;
          },
        },
      },
    ];
  },
});