window.ngui(() => {
    return {
        props: [
            'payload',
        ],
        data() {
            return {
                configModel: {
                    uuid: '',
                    task: {
                        name: 'maxpermissiblevalues',
                        algorithm: {
                            method: '',
                            model: '',
                        },
                        metric: undefined,
                    }, 
                    interval: -1,
                    nodes: [],
                    dependentVariables: [],
                    independentVariables: [],
                    explanatoryDateTimeVariables: [],
                    holidayLocation: {
                        country: '',
                        region: '',
                    },
                    minElementsPerBin: 3,
                    trainMethod: 'movingWindows',
                    trainTime: '00:00', 
                    trainingDates: [],
                    measureDates: [],
                    periodsDay: {
                        train: 60,
                        retrain: 20,
                        ignoreEvents: false,
                    },
                    sensitivityThreshold: {
                        upper: 0,
                        lower: 0,
                    },
                    eventCount: {
                        upper: 0,
                        lower: 0,
                    },
                    minErrorDistance: {
                        upper: 0,
                        lower: 0,
                    },
                    thresholdColor: '',
                    expectedValueColor: '',
                },              

                configModelLoaded: false,
                dependentNode: '',
                independentNodes: [],
            }
        },
        methods: { 
        },
        beforeMount() {
            this.ctx.filedb.read('app/BAI/configModel/'+ this.payload.widget.configModelUuid + '.json', true)
            .then((response) => {
                const configModel = response.data.data;
                this.configModel = {...this.configModel, ...configModel};

                this.dependentNode = this.configModel.nodes.filter((node) => {
                    return (`${node.pmModel.processUuid}_${node.pmModel.path}` === this.configModel.dependentVariables[0]);
                })[0];

                this.independentNodes = this.configModel.nodes.filter((node) => {
                    return (this.configModel.independentVariables.includes(`${node.pmModel.processUuid}_${node.pmModel.path}`));
                });                
                
                this.configModelLoaded = true;
            })
            .catch((err) => {
                this.ctx.log.error(err);
            });            
        },
        nodes() {
            return [
                {
                    type: 'NgText',
                    props: {
                        text: 'dependentVariable',
                        look: 'h6'
                    },
                },
                {
                    type: 'NgText',
                    props: {
                        text: this.configModelLoaded ? `${this.ctx.intelli.getNodeChartName(this.dependentNode)}` : '',
                    },
                },
                {
                    type: 'NgSpacing',
                    props: {
                        mt: 'sm',
                    },
                },                  
                {
                    type: 'NgText',
                    props: {
                        text: 'explanatoryDatapoints',
                        look: 'h6'
                    },
                },              
                {
                    type: 'NgList',
                    children: {
                        default: () => {

                            const nodes = this.independentNodes.map((node) => {
                                return {
                                    type: 'NgListItem',
                                    props: {
                                        text: node.pmModel.path,
                                    }
                                }
                            });

                            const explVars = this.configModel.explanatoryDateTimeVariables.map((vars) => {
                                return {
                                    type: 'NgListItem',
                                    props: {
                                        text: vars,
                                    }
                                }
                            });

                            return nodes.concat(explVars);
                        }
                    }
                },
                {
                    type: 'NgSpacing',
                    props: {
                        mt: 'sm',
                    },
                },                  
                {
                    type: 'NgText',
                    props: {
                        text: 'interval',
                        look: 'h6'
                    },
                },
                {
                    type: 'NgText',
                    props: {
                        text: this.ctx.intelli.getIntervalName(this.configModel.interval),
                    },
                },
                {
                    type: 'NgSpacing',
                    props: {
                        mt: 'sm',
                    },
                },                  
                {
                    type: 'NgText',
                    props: {
                        text: 'method',
                        look: 'h6'
                    },
                },
                {
                    type: 'NgText',
                    props: {
                        text: this.configModel.task.algorithm.method,
                    },
                },
                {
                    type: 'NgSpacing',
                    props: {
                        class: this.configModel.task.algorithm.method != 'thresholdsRegression' ? 'hidden' : '',
                        mt: 'sm',
                    },
                },                  
                {
                    type: 'NgText',
                    props: {
                        class: this.configModel.task.algorithm.method != 'thresholdsRegression' ? 'hidden' : '',
                        text: 'model',
                        look: 'h6'
                    },
                },
                {
                    type: 'NgText',
                    props: {
                        class: this.configModel.task.algorithm.method != 'thresholdsRegression' ? 'hidden' : '',
                        text: this.configModel.task.algorithm.model,
                    },
                },
                {
                    type: 'NgSpacing',
                    props: {
                        mt: 'sm',
                    },
                },                  
                {
                    type: 'NgText',
                    props: {
                        text: 'trainMethod',
                        look: 'h6'
                    },
                },
                {
                    type: 'NgText',
                    props: {
                        text: this.configModel.trainMethod,
                    },
                },                
                {
                    type: 'NgSpacing',
                    props: {
                        mt: 'sm',
                    },
                },                     
                {
                    type: 'NgText',
                    props: {
                        text: 'trainingDates',
                        look: 'h6'
                    },
                },                              
                {
                    type: 'NgList',
                    children: {
                        default: () => {

                            const vNodes = this.configModel.trainingDates.map((date) => {
                                return {
                                    type: 'NgListItem',
                                    props: {
                                        text: `${this.ctx.moment.getDate(date.start).format('DD.MM.YYYY')} - ${this.ctx.moment.getDate(date.end).format('DD.MM.YYYY')} `,
                                    }
                                }
                            });
                            
                            return vNodes;
                        }
                    }
                },
                {
                    type: 'NgSpacing',
                    props: {
                        mt: 'sm',
                    },
                },                  
                {
                    type: 'NgText',
                    props: {
                        text: 'trainingPeriod',
                        look: 'h6'
                    },
                },
                {
                    type: 'NgText',
                    props: {
                        text: `${this.$t('trainingPeriodDay')}: ${this.configModel.periodsDay.train}`,
                    },
                },
                {
                    type: 'NgText',
                    props: {
                        text: `${this.$t('retrainingPeriod')}: ${this.configModel.periodsDay.retrain}`,
                    },
                },
                {
                    type: 'NgSpacing',
                    props: {
                        mt: 'sm',
                    },
                },                
                {
                    type: 'NgText',
                    props: {
                        text: 'holidays',
                        look: 'h6'
                    },
                },
                {
                    type: 'NgText',
                    props: {
                        text: this.configModel.holidayLocation.country ? this.configModel.holidayLocation.region ? `${this.configModel.holidayLocation.country} (${this.configModel.holidayLocation.region})` : this.configModel.holidayLocation.country  : '-',
                    },
                },
                {
                    type: 'NgSpacing',
                    props: {
                        mt: 'sm',
                    },
                },                  
                {
                    type: 'NgText',
                    props: {
                        text: 'ignoreEvents',
                        look: 'h6'
                    },
                },
                {
                    type: 'NgText',
                    props: {
                        text: this.configModel.periodsDay.ignoreEvents ? 'yes': 'no',
                    },
                },
                {
                    type: 'NgSpacing',
                    props: {
                        mt: 'sm',
                    },
                },                  
                {
                    type: 'NgText',
                    props: {
                        text: 'sensitivity',
                        look: 'h6'
                    },
                },
                {
                    type: 'NgText',
                    props: {
                        text: `${this.$t('upper')}: ${this.configModel.sensitivityThreshold.upper}`,
                    },
                },
                {
                    type: 'NgText',
                    props: {
                        text: `${this.$t('lower')}: ${this.configModel.sensitivityThreshold.lower}`,
                    },
                },
                {
                    type: 'NgSpacing',
                    props: {
                        mt: 'sm',
                    },
                },                  
                {
                    type: 'NgText',
                    props: {
                        text: 'eventCount',
                        look: 'h6'
                    },
                },
                {
                    type: 'NgText',
                    props: {
                        text: `${this.$t('upper')}: ${this.configModel.eventCount.upper}`,
                    },
                },
                {
                    type: 'NgText',
                    props: {
                        text: `${this.$t('lower')}: ${this.configModel.eventCount.lower}`,
                    },
                },
                {
                    type: 'NgSpacing',
                    props: {
                        mt: 'sm',
                    },
                },                  
                {
                    type: 'NgText',
                    props: {
                        text: 'minErrorDistance',
                        look: 'h6'
                    },
                },
                {
                    type: 'NgText',
                    props: {
                        text: `${this.$t('upper')}: ${this.configModel.minErrorDistance.upper}`,
                    },
                },
                {
                    type: 'NgText',
                    props: {
                        text: `${this.$t('lower')}: ${this.configModel.minErrorDistance.lower}`,
                    },
                },                
            ];
        },
    }
  });