import useComponents from '/service/rest/v1/files/data/public/js/useComponent.js'
const components = useComponents()
import useProcessManager from '/service/rest/v1/files/data/public/js/useProcessManager.js'
const processManager = useProcessManager()

// Call ngui function to create a ui config.
window.ngui(() => {
  return {
  
    beforeCreate() {
      components.setParent(this)
      processManager.setParent(this)
    },

    
    // The returned object can be accessed with this within any method...
    // Do not use this.ctx within this function because it is not yet created.
    data() {
      return {
        // VAR
        processName: this.$route.query.name,
        processManagerUuid: this.$route.query.service,
        instanceUuid: this.$route.query.instance,
        processUuid: this.$route.query.process,
        processManager: {
          name: '',
        },
        instance: {
          name: '',
        },
        process: {
          name: '',
        },
        intervalId: null,
        intervalTime: 1000,
      }
    },
  
    methods: {
    },
      
    // Define elements within the ui configuration...
    nodes() {
      return [
        // any ui component node can be used...
        components.text('TBD...')
      ]
    },
  }
})