// Call ngui function to create a ui config.
window.ngui(() => {
  return {
    
    // The returned object can be accessed with this within any method...
    // Do not use this.ctx within this function because it is not yet created.
    data() {
      return {
        // VAR
        settings: {
          keyboard: false,
        },
      }
    },

    watch: {
      'settings.keyboard'(val){
        this.ctx.user.store.lsSetJSON('keyboard', val)
      },
    },

    mounted() {
      this.settings.keyboard = this.ctx.user.store.lsGetJSON('keyboard') || false;
    },
    
    // Define elements within the ui configuration...
    nodes() {
      return [
        // any ui component node can be used...
        window.components.page(this.ctx.globals.getPermissions(['serverSettingsRead'])).append(() => [
          window.components.breadcrumbs([
            {
              label: this.$t('settings'),
              to: '/settings'
            },
            {
              label: this.$t('general'),
              to: '/settings/general'
            }
          ]),
          window.components.bar('general'),
          window.components.section().attrs({ class: 'flex justify-center' }).append(() => [
            window.components.card().attrs({ flat: false, class: 'full-width', style: { maxWidth: '1200px' }}).append(() => [
              window.components.section().append(() => [
                window.components.element('div').attrs({
                  class: 'column q-gutter-md',
                }).append(() => [
                  window.components.input('keyboard', 'toggle', this.settings.keyboard, (val) => this.settings.keyboard = val).attrs({
                    hint: 'displayKeyboardButton',
                    class: 'col-12',
                  }),
                  window.components.button('reload', 'mdi-refresh').attrs({
                    class: 'col-12',
                  }).on({
                    onClick: () => this.$router.go(0),
                  }),
                ])
              ])
            ]),
          ])
        ])
      ]
    },
  }
})