// Call ngui function to create a ui config.
window.ngui(() => {
  return {
    
    // The returned object can be accessed with this within any method...
    // Do not use this.ctx within this function because it is not yet created.
    data() {
      return {
        // VAR
        editable: true,
      }
    },
    
    // Define elements within the ui configuration...
    nodes() {
      return [
        // any ui component node can be used...
        window.components.page([34]).append(() => [
          window.components.breadcrumbs([
            {
              label: this.$t('userManagement'),
              to: '/users'
            },
            {
              label: this.$t('roles'),
              to: '/users/roles'
            }
          ]),
          window.components.bar('roles'),
          window.components.section().append(() => [
            window.components.card().attrs({ flat: false }).append(() => [
              window.components.element('NgUsersMgmtRoles').attrs({ editable: this.editable, maxHeight: '80vh' }),
            ]),
          ])
        ])
      ]
    },
  }
})