// Call ngui function to create a ui config.
window.ngui(() => {
  return {
    props: [
      'design',
	  'serviceUuids',
      'item',
      'computedObject',
      'panel',
    ],

    icon: 'mdi-keyboard-space',
    
    config: {
      startPanel: 'properties',
      panels: [
        {
          header: 'properties',
          name: 'properties',
          items: [
            {
              type: 'form',
              props: {
                scope: 'data',
                schema: [
                  {
                    type: 'checkbox',
                    default: false,
                    label: 'hidden',
                    scope: 'attrs.hidden',
                    col: 'col-12',
                    sideSlot: 'link',
                  },
                  {
                    type: 'text',
                    default: '5px',
                    label: 'height',
                    scope: 'attrs.minHeight',
                    col: 'col-12 col-md-6',
                    sideSlot: 'link',
                  },
                  {
                    type: 'color-palette',
                    default: '',
                    label: 'color',
                    scope: 'attrs.bgColor',
                    col: 'col-12 col-md-6',
                    isBackground: true,
                    sideSlot: 'link',
                  },
                  {
                    type: 'permissions',
                    default: [],
                    label: 'readPermissions',
                    hint: 'readPermissionsDescription',
                    scope: 'rights.read',
                    col: 'col-12',
                  },
                ]
              },
            }
          ]
        }
      ]
    },
	
    // The returned object can be accessed with this within any method...
    // Do not use this.ctx within this function because it is not yet created.
    data() {
      return {
      }
    },

    watch: {
      'item.attrs': {
        handler() {
          this.panel.setPermissions(this.item.rights, this.item)
        },
        deep: true,
      },
    },

    // Listen on mounted event...
    mounted() {
      this.panel.setPermissions(this.item.rights, this.item)
    },
	
    // Listen on mounted event...
    unmounted() {
    },
	
    methods: {
    },
	
    // Define elements within the ui configuration...
    nodes() {
      return [
        // any ui component node can be used...
        {
          type: 'div',
          props: {
            ...this.item.attrs,
            class: this.item.attrs.bgColor,
            style: {
              minHeight: this.item.attrs.minHeight,
            }
          },
        },
      ]
    },
  }
})